# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [Unreleased]
### Added
- Auf der jeweiligen Informationsseite zu einem Autor gibt es nun einen Button, der zur Werkübersicht zurückführt.
- Neuigkeiten auf der Startseite.
- Darstellung von zitierten Passus in Bahrdt/Semler in der digitalen Ansicht.
- Darstellung von editorischen Fußnoten in Bahrdt/Semler.
### Changed
- Update auf eXist-db 4.7.0.
- Die Navigation im Reiter "Editionen" wurde aktualisiert.
- Die Sprache des Changelogs wurde auf Deutsch geändert.
- Der Text von Lemmata sind nun immer hervorgehoben, wenn die zugehörige Variante sichtbar ist (nicht nur beim Hover über die Variante).
- Die Werkübersicht wurde auf den neuen Mechanismus für das semantische Splitten der Gesamt-XMLs angepasst. Zudem wurden Untereinträge eingeführt, die für mehr Übersichtlichkeit sorgen.
### Fixed
- Bug im semantischen Splitten der Gesamt-XMLs behoben.
- Bug in der Editionsnavigation behoben: Link unter "Ansicht" > "Editorisches Vorwort" korrigiert.


## [4.4.0] - 2019-05-17
### Added
- Mobile Friendliness: Navbar für alle Editionsansichten auf kleinen Geräten (sm oder xs breakpoint).
- Registeransicht wurde leicht überarbeitet.
- Serialisierung der editorischen Vorworte.
- Anpassungen an die neueste Schemaerweiterung.


### Changed
- Registeransichten werden nun während xml-utils:main erzeugt.
- Entfernen von zirkulären Abhängigkeiten in utils.xqm/whitelist.xqm und utils.xqm/nav-utils.xqm.
- Update auf eXist-db 4.6.1.
- Schemadokumentation wird nun mit SADEs ODD Serializer angezeigt.
- Die Navigation in den Editionsansichten berücksichtigt nun spezielle Anforderungen von Bahrdt/Semler.
- Die interaktive Ansicht von Bahrdt/Semler hat nur noch eine Spalte.
- Das Abkürzungsicon wurde durch eine Unterstreichung des betreffenden Texts ersetzt.

### Fixed
- Bug in der Erzeugung der TEI/XML-Ansicht behoben.
- Es werden nur noch Register, die in einem Werk vorkommen, angezeigt.
- Bug im Zählen der tei:rdg in der textkritischen Ansicht behoben.
- Verrücken des Texts wenn ein Modalfenster geöffnet wird getilgt.
- Mehrfacheinträge von Buchstaben in der Registernavigation getilgt.
- Kleinere Bugs in Bahrdt/Semler behoben.
- Erzeugung der TEI/XML-Ansicht funktioniert jetzt für alle vier Autoren in der Pipe (Nösselt, Griesbach, Leß, Bahrdt/Semler)
- Bug in Griesbach behoben, durch den ein komplett ausgelassenes tei:item keine Hintergrundfarbe in der interaktiven Anicht hatte.

## [4.3.0] - 2018-10-19
### Added
- Ein kompletter Workflow, mit dem alle XML eines Werks sowie die während des Splittens erzeugten XML in whitelist.xml eingefügt werden.

### Changed
- Kleinere Umbenennungen von Funktionsnamen und Variablen (code quality).


## [4.2.0] - 2018-10-19
### Added
- Die Listenübersicht für alle Registertypen unter index-overview.html.

### Changed

### Removed
