var sid;
var sadeUser;
var sadePw;
var page;
var t;
var i;
var test;


function updateOverview() {
	log('starting...');

	$('#logbox').show();
        if(sadeUser === undefined) {
            sadeUser = $('#user').val();
            sadePw = $('#password').val();
            sid = $('#sid').val();
        }

		var sidreq = sid ? "&sid="+sid : "";
        var target="data";

		$.ajax({
		    type: 'POST',
			url: 'modules/textgrid/custom-publish.xq',
			data: {'user': sadeUser, 'password': sadePw, 'sid': sid, 'operation': 'overview'},
			cache: false,
			success: function(xml) {
                test = $(xml).find('message');
			    if($(xml).find('ok').text()) {
			        $(xml).find('ok').each( function(){
			                log('success: ' + $(this).text() );
                        });
			    }
			},

			error: function(xml){
			    message = xml.responseXML.childNodes["0"].childNodes[1].textContent
			    log('<span style="color:red;">ERROR: ' + message + '</span>');
			}
		});
}

function updateIndices() {
	log('starting...');

	$('#logbox').show();
        if(sadeUser === undefined) {
            sadeUser = $('#user').val();
            sadePw = $('#password').val();
            sid = $('#sid').val();
        }

		var sidreq = sid ? "&sid="+sid : "";
        var target="data";

		$.ajax({
		    type: 'POST',
			url: 'modules/textgrid/custom-publish.xq',
			data: {'user': sadeUser, 'password': sadePw, 'sid': sid, 'operation': 'indices'},
			cache: false,
			success: function(xml) {
                test = $(xml).find('message');
			    if($(xml).find('ok').text()) {
			        $(xml).find('ok').each( function(){
			                log('success: ' + $(this).text() );
                        });
			    }
			},

			error: function(xml){
			    message = xml.responseXML.childNodes["0"].childNodes[1].textContent
			    log('<span style="color:red;">ERROR: ' + message + '</span>');
			}
		});
};

/**
 * This functions sets the dimensions of the SVG-layer equally to those of the container of the digital edition.
 * This allows for correct positioning of paths between lemmata and readings.
 * @function
 */
const setSvgLayer = function setSvgLayer() {   
    svgLayer.style.top = digitalText.offsetTop + "px";
    svgLayer.style.height = edition.offsetHeight + "px";
    svgLayer.style.left = edition.offsetLeft + "px";
    svgLayer.style.width = edition.offsetWidth + "px";
};

/**
 * This function resizes the edition container to make sure that the footer 
 * stays at the bottom of the page. This is necessary where a large
 * number of readings is opened, as they may exceed the footer in these cases.
 * @function
 */
const resizeEdition = function resizeEdition() {
    let openRdgs = document.getElementsByClassName("show");
    let lowestRdg = false;
    for (i = 0; i < openRdgs.length; i++) {
        lowestRdg === false ? lowestRdg = openRdgs[i]
        : openRdgs[i].offsetTop > lowestRdg.offsetTop ? lowestRdg = openRdgs[i] : lowestRdg;
    };
    digitalText.style.height = lowestRdg.offsetTop + "px"
    setSvgLayer();
};

/**
 * This function vertically positions a span containing a reading, either at the
 * same height as the corresponding lemma, or at a different height when it would
 * overlap other readings.
 * 
 * @function
 * @param {object} rdg A span containing a reading.
 */
const positionRdg = function positionRdg(rdg) {
    let openRdgs = document.querySelectorAll(".show");
    let lemmaId = rdg.getAttribute("target-lem").replace("#", "");
    let lemma = document.getElementById(lemmaId);
    let rdgPos = lemma.offsetTop + buttonrow.offsetHeight;
    let rdgBottom = rdgPos + rdg.offsetHeight;
    
    for (openedRdg of openRdgs) {
        if (openedRdg != rdg) {
            let openedRdgTop = parseFloat(openedRdg.style.top);
            let openedRdgBottom = openedRdgTop + openedRdg.offsetHeight;
            rdgPos >= openedRdgTop - 5 && rdgPos <= openedRdgBottom + 5 || rdgPos <= openedRdgTop - 5 && rdgBottom >= openedRdgBottom + 5
                ? rdgPos = openedRdgBottom + 5 
                : rdgPos;
        }
    };
    rdg.style.top = rdgPos + "px";
};

/**
 * This function draws a SVG-path between a lemma and a corresponding reading
 * and displays it.
 * 
 * @function
 * @param {object} lemma A span containing a lemma.
 * @param {object} rdg A span containing a reading.
 */
const drawPath = function drawPath(lemma, rdg) {
    let rdgId = rdg.id;
    let path = document.querySelector("[target-rdg='#" + rdgId + "']");

    let pathXStart = lemma.offsetWidth >= (digitalText.offsetWidth - 35) ? (35) 
        : (lemma.offsetLeft + lemma.offsetWidth / 2) >= digitalText.offsetWidth ? 60 
        : (lemma.offsetLeft + lemma.offsetWidth / 2);
    let pathYStart = lemma.offsetTop + lemma.offsetHeight -1;
    let pathXEnd = variants.offsetLeft - lemma.offsetParent.offsetLeft + 15;
    let pathYEnd = rdg.offsetTop - buttonrow.offsetTop - buttonrow.offsetHeight + rdg.offsetHeight / 2;
    
    let pathMod = pathYStart + 10 < pathYEnd ? "q 3 0 3 3 V " + pathYEnd + " q 0 3 3 3"
        : pathYStart - 10 > pathYEnd ? "q 3 0 3 -3 V " + pathYEnd + " q 0 -3 3 -3"
        : "";

    path.setAttribute("d", "M " + pathXStart + " " + pathYStart + " q 0 3 3 3 H " + digitalText.offsetWidth + pathMod + " H " + pathXEnd);
    path.classList.add("visible");
};

/**
 * This function opens a reading, positions it, highlights the corresponding lemma
 * and draws a SVG-path between the two. This function is called when one of the
 * variant buttons is clicked.
 * 
 * @function
 * @param {object} rdg A span containing a reading.
 */
const openRdg = function openRdg(rdg) {
    let lemmaId = rdg.getAttribute("target-lem").replace("#", "");
    let lemma = document.getElementById(lemmaId);
    let path = document.querySelector(".rdg-path[target-rdg='#" + rdg.id + "']");
    
    lemma.classList.add("highlight-lem");
    positionRdg(rdg);
    rdg.classList.add("show");
    drawPath(lemma, rdg);
    rdg.offsetTop > edition.offsetHeight ? resizeEdition() : "";
};

/**
 * This function closes a reading when the reading, its corresponding lemma or
 * the variant button is clicked.
 * 
 * @function
 * @param {object} rdg A span containing a reading.
 */
const closeRdg = function closeRdg(rdg) {
    let lemmaId = rdg.getAttribute("target-lem").replace("#", "");
    let lemma = document.getElementById(lemmaId);
    let path = document.querySelector(".rdg-path[target-rdg='#" + rdg.id + "']");
    
    /** do not remove highlighting from corresponding lemma if there is another
     * open reading corresponding to that lemma.
     */
    document.querySelectorAll(".show[target-lem='#" + lemmaId + "']").length > 1 ? "" : lemma.classList.remove("highlight-lem");
    rdg.classList.remove("show");
    rdg.style.top = "";
    path.classList.remove("visible");
};

/**
 * This function handles the highlighting of a lemma when clicked and calls the 
 * display of any relevant readings, as well as drawing the paths between them.
 * 
 * @function
 * @param {object} lem A span containing a lemma.
 */
const openLemma = function openLemma(lem) {
    let id = lem.id;
    let relevantRdgs = document.querySelectorAll(".rdg-digital[target-lem='#" + id + "']");

    lem.classList.add("highlight-lem");
    for (rdg of relevantRdgs) {
        positionRdg(rdg);
        rdg.classList.add("show");
        drawPath(lem, rdg);
    };
    rdg.offsetTop > edition.offsetHeight ? resizeEdition() : "";
};

/**
 * This function closes a lemma and all its corresponding readings.
 * 
 * @function
 * @param {object} lem A span containing a lemma.
 */
const closeLemma = function closeLemma(lem) {
    let id = lem.id;
    let relevantRdgs = document.querySelectorAll(".rdg-digital[target-lem='#" + id + "']");
    
    lem.classList.remove("highlight-lem");
    for (rdg of relevantRdgs) {
        closeRdg(rdg);
    };
};

/**
 * This is a wrapper function, checking whether a clicked lemma is open or closed.
 * 
 * @function
 */
const toggleLemma = function toggleLemma() {
    this.classList.contains("highlight-lem") ? closeLemma(this) : openLemma(this);
};

/**
 * This function opens or closes all readings of a particular witness. 
 * If there are any closed readings corresponding to that witness, all remaining
 * closed readings are opened. Otherwise, all readings corresponding to that
 * witness will close.
 * 
 * @function
 */
const toggleAllLemmata = function toggleAllLemmata() {
    let buttonId = this.id;
    let witness = buttonId.charAt(buttonId.length - 1);
    let openRdgs = document.querySelectorAll(".show.rdg-digital[wits*='" + witness + "']");
    let closedRdgs = document.querySelectorAll(":not(.show).rdg-digital[wits*='" + witness + "']");

    if (closedRdgs.length > 0) {
        for (rdg of closedRdgs) {openRdg(rdg)};
    } else {
        for (rdg of openRdgs) {closeRdg(rdg)};
    }
};

/**
 * This function highlights a lemma on mouseover, its correspoding reading or 
 * readings, as well as the path or paths between them.
 * 
 * @function
 */
const mouseOverLem = function mouseOverLem() {
    let id = this.id;
    let rdg = document.querySelector("[target-lem='#" + id + "']");
    let path = document.querySelector(".rdg-path[target-lem='#" + id + "']");
    
    this.classList.toggle("highlight-lem-hover");
    rdg.classList.toggle("highlight-show");
    path.classList.toggle("highlight-show");
};

/**
 * This function highlights a reading on mouseover, as well as its corresponding
 * lemma and the path between the two.
 * 
 * @function
 */
const mouseOverRdg = function mouseOverRdg() {
    let id = this.id;
    let lemId = this.getAttribute("target-lem").replace("#", "");
    let lem = document.getElementById(lemId);
    let path = document.querySelector(".rdg-path[target-rdg='#" + id + "']");
    
    this.classList.toggle("highlight-show");
    lem.classList.toggle("highlight-lem-hover");
    path.classList.toggle("highlight-show");
};

/**
 * This function sets the dimensions of the SVG-layer, as well as the position
 * of any opened readings and their corresponding paths, when the screen is
 * resized.
 * 
 * @function
 */
const onScreenResize = function onScreenResize() {
    let openRdgs = document.querySelectorAll(".show");

    setSvgLayer();
    for (rdg of openRdgs) {
        let lemmaId = rdg.getAttribute("target-lem").replace("#", "");
        let lemma = document.getElementById(lemmaId);
        positionRdg(rdg);
        drawPath(lemma, rdg);
    };
};


/**
 * This function handles the highlighting of a quote when clicked and calls the 
 * display of the full quotation.
 * 
 * @function
 * @param {object} icon A span containing a quoteS.
 */
const openQuote = function openQuote(quote) {
    let id = quote.id;
    let fullQuote = document.querySelector(".quoted-text[target-node='#" + id + "']");

    quote.classList.add("highlight-quote");
    fullQuote.style.top = quote.offsetTop + "px";
    fullQuote.classList.add("show");
    fullQuote.offsetTop > edition.offsetHeight ? resizeEdition() : "";
};

/**
 * This function closes a quote and all the full quotation.
 * 
 * @function
 * @param {object} quote A span containing a quote.
 */
const closeQuote = function closeQuote(quote) {
    let id = quote.id;
    let fullQuote = document.querySelector(".quoted-text[target-node='#" + id + "']");
    
    quote.classList.remove("highlight-quote");
    fullQuote.classList.remove("show");
};

/**
 * This is a wrapper function, checking whether a clicked quote is open or closed.
 * 
 * @function
 */
const toggleQuoteIcon = function toggleQuoteIcon() {
    let quote = this.parentElement;
    quote.classList.contains("highlight-quote") ? closeQuote(quote) : openQuote(quote);
};

/**
 * This function closes a long quotation when clicked.
 * 
 * @function
 * @param {object} fullquote A span containing a longer version of a quote.
 */
const closeFullQuote = function closeFullQuote(fullquote) {
    let id = fullquote.id;
    let quote = document.querySelector(".quote[target-node='" + id + "']");
    
    fullquote.classList.remove("show");
    quote.classList.remove("highlight-quote");
};

/**
 * This function highlights a short quote and its corresponding longer version
 * on mouseover over the quotation icon.
 * 
 * @function
 */
const mouseOverQuoteIcon = function mouseOverQuoteIcon() {
    let id = this.parentElement.id;
    let fullQuote = document.querySelector(".quoted-text[target-node='#" + id + "']");
    console.log(fullQuote);
    
    this.parentElement.classList.toggle("highlight-quote-hover");
    fullQuote.classList.toggle("highlight-quote-hover");
};

/**
 * This function highlights a short quote and its corresponding longer version
 * on mouseover over the longer quotation.
 * 
 * @function
 */
const mouseOverFullQuote = function mouseOverFullQuote() {
    let id = this.id;
    let quote = document.querySelector(".quote[target-node='" + id + "']");

    this.classList.toggle("highlight-quote-hover");
    quote.classList.toggle("highlight-quote-hover");
};

/**
 * Get all necessary constant elements: 
 * Lemmata, readings, the variants button or buttons, quotations and some areas.
 */
const lems = document.querySelectorAll(".lem[wits]");
const rdgs = document.getElementsByClassName("rdg-digital");
const variantsButtons = document.getElementsByClassName("variants-btn");
const buttonrow = document.querySelector(".variants-btns");
const quoteIcons = document.getElementsByClassName("quote-icon");
const quotes = document.getElementsByClassName("quoted-text");
const edition = document.getElementById("edition");
const digitalText = document.getElementById("digital-text");
const variants = document.getElementById("variants");
const svgLayer = document.querySelector(".svg-layer");

document.addEventListener("DOMContentLoaded", setSvgLayer);
window.addEventListener("resize", onScreenResize);

for (i = 0; i < lems.length; i++) {
    lems[i].addEventListener("click", toggleLemma, false);
    lems[i].addEventListener("mouseenter", mouseOverLem, false);
    lems[i].addEventListener("mouseleave", mouseOverLem, false);
};

for (i = 0; i < rdgs.length; i++) {
    rdgs[i].addEventListener("click", function(){closeRdg(this)}, false);
    rdgs[i].addEventListener("mouseenter", mouseOverRdg, false);
    rdgs[i].addEventListener("mouseleave", mouseOverRdg, false);
};

for (i = 0; i < variantsButtons.length; i++) {
    variantsButtons[i].addEventListener("click", toggleAllLemmata, false);
};

for (i = 0; i < quoteIcons.length; i++) {
    quoteIcons[i].addEventListener("click", toggleQuoteIcon, false);
    quoteIcons[i].addEventListener("mouseenter", mouseOverQuoteIcon, false);
    quoteIcons[i].addEventListener("mouseleave", mouseOverQuoteIcon, false);
};

for (i = 0; i < quotes.length; i++) {
    quotes[i].addEventListener("click", function(){closeFullQuote(this)}, false);
    quotes[i].addEventListener("mouseenter", mouseOverFullQuote, false);
    quotes[i].addEventListener("mouseleave", mouseOverFullQuote, false);
};

/* Fixing a bug in Bootstrap where the Navbar hides content.
 * See https://github.com/twbs/bootstrap/issues/1768

var shiftWindow = function() { scrollBy(0, -50) };
if (location.hash) shiftWindow();
window.addEventListener("hashchange", shiftWindow);
*/

/**
 * Sitemap
 */

$("ul.sitemap ul").hide();

$("ul.sitemap i").click(function() {
    if ($(this).hasClass("fa-caret-right")) {
        $(this).removeClass("fa-caret-right").addClass("fa-caret-down");
        $(this).closest("ul").find("ul").show();
    } else if ($(this).hasClass("fa-caret-down")) {
        $(this).removeClass("fa-caret-down").addClass("fa-caret-right");
        $(this).closest("ul").find("ul").hide();
    }
});

$("a > i, div > i").click(function() {
    if ($(this).hasClass("fa-caret-down")) {
        $(this).removeClass("fa-caret-down").addClass("fa-caret-up");
    }
    else if($(this).hasClass("fa-caret-up")) {
        $(this).removeClass("fa-caret-up").addClass("fa-caret-down");
    }
});



/**
 * Interaction with elements (on click)
 */

$("a.textLink, .modelledition, [type='notAvailable'], .modal, .fa-book-link").click(function(e) {
  e.stopPropagation();
//  return true;
});


/**
 * RDF objects
 */

$(".fa-user-link").click(function(e) {
    e.stopPropagation();
    var uri = document.getElementById(this.id).getAttribute("tgURI");

    $.get('templates/rest/persons.xql?id=' + uri, function(data) {
        var template = $('#modalUserTpl').html(); /* in page.html */
        var html = Mustache.to_html(template, data);
        $('.modalArea').html(html); /* in book.html */

        $(html).modal('show');
    });
});

$(".fa-user-link").mouseover(function(e) {
    var id = document.getElementById(this.id).getAttribute("id");
    var uri = document.getElementById(this.id).getAttribute("tgURI");

    $.get('templates/rest/persons.xql?id=' + uri, function(data) {
        var template = "{{person.dnb.name}}{{person.cerl.name}}";
        var html = Mustache.render(template, data);
        /* during the query all ' are replaced with &#39; */
        html = html.replace(/&#39;/g, "'");

        $("#" + id).attr("title", html);
    });
});


$(".fa-book-link").click(function(e) {
    e.stopPropagation();
    e.preventDefault();

    var tempID = document.getElementById(this.id).getAttribute("id");
    var uri = document.getElementById(this.id).getAttribute("tgURI");

    $.get('templates/rest/books.xql?id=' + uri, function(data) {

        var template = $('#modalBookTpl').html();
        var html = Mustache.render(template, data);
        $('.modalArea').html(html);

        $(html).modal('show');
    });
});


$(".fa-book-link").mouseover(function(e) {
    e.stopPropagation();

    var id = document.getElementById(this.id).getAttribute("id");
    var uri = document.getElementById(this.id).getAttribute("tgURI");

    $.get('templates/rest/books.xql?id=' + uri, function(data) {
        var template = "{{book.opac}}";
        var html = Mustache.render(template, data);
        /* during the query all slashes are replaced with &#x2F; */
        html = html.replace(/&#x2F;/g, "/");

        $("#" + id).attr("href", html);
    });
});


$("#book .fa-comment").click(function(e) {
    e.stopPropagation();
    var target = this.getAttribute("data-target");

    $(target).modal('show');
});


$(".comp-error").click(function(e) {
    e.stopPropagation();

    var target_id = $(this).attr("data-target").replace("#", "");
    var target = $("div[id=" + target_id + "]");

    $(target).modal('show');
});


$(".editorial-commentary, .expan-content").click(function(e) {
    e.stopPropagation();
    $(this).parent().hasClass("lem") ? $(this).parent().click() : "";

    var target_id = $(this).attr("href").replace("#", "");
    var target = $("div[id=" + target_id + "]");

    $(target).modal('show');
});


/* temporary solution for the sample edition. has to be adjusted for real edition! */
$(document).ready(function() {

    $("[type='notAvailable'] i").css({"color": "#595959", "cursor": "default"});

    var stickyTop = $('#register-nav').offset().top - 45; // returns number considering the header
    $(window).scroll(function(){
        var windowTop = $(window).scrollTop(); // returns number
        if (stickyTop < windowTop) {
            $('#register-nav').css({ position: 'fixed', top: '51px', width: '59.4%' });
        }
        else {
            $('#register-nav').css({position: 'static', width: '100%', });
        }
    });

    /*via http://www.jquerybyexample.net/2012/06/get-url-parameters-using-jquery.html
    http://stackoverflow.com/questions/19491336/get-url-parameter-jquery-or-how-to-get-query-string-values-in-js */

    var getUrlParameter = function getUrlParameter(sParam) {
        var sPageURL = decodeURIComponent(window.location.search.substring(1)),
            sURLVariables = sPageURL.split('&'),
            sParameterName,
            i;

        for (i = 0; i < sURLVariables.length; i++) {
            sParameterName = sURLVariables[i].split('=');

            if (sParameterName[0] === sParam) {
                return sParameterName[1] === undefined ? true : sParameterName[1];
            }
        }
    };


    /* highlighting words or substrings if document is called from result.html
    (after search operation) */

    var highlight = getUrlParameter('key');
    var expand = getUrlParameter('expand');
    var keyArray;

    if(highlight.toLowerCase().indexOf('*') > -1){
        $(".corner-button").css({"display": "inline"});

        if(highlight.toLowerCase().indexOf('+') > -1) {
            keyArray = highlight.split('+');
        }
        else
            keyArray = highlight.split('*');

        var iii;
        for(iii = 0; iii < keyArray.length; iii++) {
            if(keyArray[iii].indexOf('*') > -1) {
                var keyArrayTmp = keyArray[iii].split('*');

                var jjj;

                for(jjj = 0; jjj < keyArrayTmp.length; jjj++) {
                    $("div > div.p").highlight(keyArrayTmp[jjj]);
                }
            }
            $("div > div.p").highlight(keyArray[iii]);
        }
    }
    else if(highlight.toLowerCase().indexOf('+') !== 0) {
        $(".corner-button").css({"display": "inline"});

        keyArray = highlight.split('+');

        var iii;
        for(iii = 0; iii < keyArray.length; iii++) {
            $("div > div.p").highlight(keyArray[iii]);
        }
    }
    else if(hightlight) {
        $(".corner-button").css({"display": "inline"});
        $("div > div.p").highlight(highlight);
    }
});


/* activating loader icon if ajax is active */
$body = $("body");

$(document).bind({
    ajaxStart: function() { $body.addClass("loading");    },
    ajaxStop: function() { $body.removeClass("loading"); }
});


$('.help').mouseover(function(e)
 {
    $(this).tooltip('show');
 });


$('.result p').css('margin-bottom', '20px');
$('.result p').after('<hr/>');
/*var content = $('.result p').html();


$('.result p').replaceWith('<li class="list-group-item">' + content + '</li>');*/


$('.dropdown-submenu .submenu-link').on("click", function(e) {
    $(this).next('ul').toggle();
    e.stopPropagation();
    e.preventDefault();
});

function sendMail() {
    var subject = encodeURIComponent(document.getElementById('mailSubject').value)
    var body = encodeURIComponent(document.getElementById('mailContent').value + '\n')

    var link = "mailto:neologie@gwdg.de"
             + "?subject=" + subject
             + "&body=" + body
    ;

    window.location.href = link;
}


/* hide overlay for small screens */

function hideOverlay() {
    $('#small-screen-warning').addClass("small-screen-hide");
}


/* disable links to printings for which there is no text (because of structural
variance) */
$("a.disabled").click(function(e) {
    e.stopPropagation();
    e.preventDefault();
});

$(".navbar-work-btn").click(function(e) {
    e.stopPropagation();
    e.preventDefault();

    if ($(this).find("svg").hasClass("fa-caret-down")) {
        $(this).removeClass("fa-caret-down").addClass("fa-caret-up");
    } else if ($(this).find("svg").hasClass("fa-caret-up")) {
        $(this).removeClass("fa-caret-up").addClass("fa-caret-down");
    }

    $(this).next(".navbar-work-subitem-container").toggle();
});

$(".overview-entry").click(function(e) {
    e.stopPropagation();
    e.preventDefault();

    $(this).find(".svg-inline--fa").toggleClass("fa-caret-down").toggleClass("fa-caret-up");

    $(this).next(".overview-subentry-container").children().toggleClass("overview-show");

});

/* to hightlight currently selected view */

$(".edition-menu-link").click(function() {
    var currentUrl = String(window.location);
    $(".edition-menu-dropdown a.dropdown-item").filter(function() {
        return currentUrl.endsWith($(this).attr("href"));
    }).addClass("current");
});

var width = 290,
    height = 210,
    radius = Math.min(width, height) / 2,
    color = d3.scale.category20c();

var svg = d3.select("svg#chart")
    .attr("width", width)
    .attr("height", height)
    .append("g")
    .attr("transform", "translate(" + width / 2 + "," + height / 2 + ")");

var partition = d3.layout.partition()
    .sort(null)
    .size([2 * Math.PI, radius * radius])
    .value(function(d) { return 1; });

var arc = d3.svg.arc()
    .startAngle(function(d) { return d.x; })
    .endAngle(function(d) { return d.x + d.dx; })
    .innerRadius(function(d) { return Math.sqrt(d.y); })
    .outerRadius(function(d) { return Math.sqrt(d.y + d.dy); });

function draw(json) {
    var path = svg.datum(json).selectAll("path")
        .data(partition.nodes)
        .enter().append("path")
        .attr("display", function(d) { return d.depth ? null : "none"; }) // hide inner ring
        .attr("d", arc)
        .style("stroke", "#fff")
        .style("fill", function(d) { return color((d.children ? d : d.parent).name); })
        .style("fill-rule", "evenodd")
        .each(stash)
        .on('mouseover', function(d){ $("strong#legend").text(d.name)});

    /* d3.selectAll("input").on("change", function change() {
        var value = this.value === "count"
            ? function() { return 1; }
            : function(d) { return d.size; };

        path
            .data(partition.value(value).nodes)
            .transition()
            .duration(1500)
            .attrTween("d", arcTween);
    }); */
}

// Stash the old values for transition.
function stash(d) {
    d.x0 = d.x;
    d.dx0 = d.dx;
}

// Interpolate the arcs in data space.
function arcTween(a) {
    var i = d3.interpolate({x: a.x0, dx: a.dx0}, a);
    return function(t) {
        var b = i(t);
        a.x0 = b.x;
        a.dx0 = b.dx;
        return arc(b);
    };
}

function getJSON(element, curLevel, maxLevel) {
    var result = {
        name: "tei:" + element.tagName
    };

    if (curLevel < maxLevel && $(element).children().length > 0) {
        var children = [];

        $(element).children().each(function() {
            children.push(getJSON(this, curLevel + 1, maxLevel));
        });

        result["children"] = children;
        return result;
    } else {
        var size = 0;

        $(element).find("*").each(function() {
            size += $(this).text().length;
        });

        /* var size = $(element).find("*").length; */

        result["size"] = size;
        return result;
    }
};

$.ajax({
    type: "GET",
    url: "/exist/rest/db/sade-projects/textgrid/data/xml/data/24ds1.0.xml?_xsl=no"
}).done(function(data) {
    draw(getJSON($(data).find("TEI", "tei\\:TEI")[0], 1, 5));
});
